//====================================
//The custom UI header
//====================================

AddTimer(0.1, function()
{
    local scores = GetSortedScores();
    local place1 = PlayerInstanceFromIndex(scores[0][0]);
    local place2 = PlayerInstanceFromIndex(scores[1][0]);

    foreach (player in GetAllClients())
    {
        local opponent = place1 != player ? place1 : place2;
        if (!IsValidPlayer(opponent))
            opponent = worldspawn;

        local username = GetPropString(opponent, "m_szNetname");
        username = username.slice(0, min(username.len(), 12));
        game_text_left.Display(username, player);

        username = GetPropString(player, "m_szNetname");
        username = username.slice(0, min(username.len(), 12));
        game_text_right.Display(username, player);

        local scoreText = format("%02d%32s%02d", GetScore(opponent), "", GetScore(player));
        game_text_scores.Display(scoreText, player);

        /*local username = GetPropString(opponent, "m_szNetname");
        username = username.slice(0, min(username.len(), 12));
        username ="You\n"+username
        game_text_left.Display(username, player);

        local scoreText = format("%02d\n%02d", GetScore(player), GetScore(opponent));
        game_text_scores.Display(scoreText, player);*/
    }
});

//====================================
//Taking over the stock scoreboard
//====================================

tf_player_manager.ValidateScriptScope();
tf_player_manager.GetScriptScope().ThinkScoreboard <- function()
{
    foreach (player in GetPlayers())
        SetPropIntArray(tf_player_manager, "m_iTotalScore", GetScore(player), player.entindex());
    return -1;
}
AddThinkToEnt(tf_player_manager, "ThinkScoreboard");
tf_player_manager.AddFlag(EFL_NO_THINK_FUNCTION);

OnGameEvent("player_spawn", function(player)
{
    local isBot = player.IsFakeClient();
    if (!isBot)
        player.AddFlag(FL_FAKECLIENT);

    SendGlobalGameEvent("player_escort_score",
    {
        player = player.entindex(),
        points = -1
    });

    if (!isBot)
        player.RemoveFlag(FL_FAKECLIENT);
});