antiWinLoop <- false;
::hasRoundEnded <- false;
roundWinner <- worldspawn;

function EndRound(winner = null)
{
    if (hasRoundEnded)
        return;
    hasRoundEnded <- true;
    if (!winner)
        winner = PlayerInstanceFromIndex(GetFirstPlace()[0]);
    if (!winner)
        winner = worldspawn;
    roundWinner = winner;

    local roundWin = SpawnEntityFromTable("game_round_win",
    {
        win_reason = "0",
        force_map_reset = "1", //not having
        TeamNum = "0",         //these 3 lines
        switch_teams = "0"     //causes the crash when trying to fire game_round_win
    });
    EntFireByHandle(roundWin, "SetTeam", ""+winner.GetTeam(), 0.1, null, null);
    EntFireByHandle(roundWin, "RoundWin", "", 0.1, null, null);
    return;
}

OnGameEvent("teamplay_win_panel_post", 0, function(params)
{
    SendGlobalGameEvent("tf_game_over", {})

    EmitSoundEx({
        sound_name = "player/taunt_bell.wav",
        volume = 1,
        sound_level = 150,
        filter_type = RECIPIENT_FILTER_GLOBAL
    });

    local scores = GetSortedScores();
    local place1 = PlayerInstanceFromIndex(scores[0][0]);
    local place2 = PlayerInstanceFromIndex(scores[1][0]);
    local place3 = PlayerInstanceFromIndex(scores[2][0]);
    if (!IsValidPlayer(place1))
        place1 = worldspawn;
    if (!IsValidPlayer(place2))
        place2 = worldspawn;
    if (!IsValidPlayer(place3))
        place3 = worldspawn;

    ClientPrint(null, 3, "First Place: " + scores[0][1]+" "+GetPropString(place1, "m_szNetname"));
    ClientPrint(null, 3, "Second Place: " + scores[1][1]+" "+GetPropString(place2, "m_szNetname"));
    ClientPrint(null, 3, "Third Place: " + scores[2][1]+" "+GetPropString(place3, "m_szNetname"));


    foreach(player in GetPlayers())
    {
        if (player == roundWinner)
            continue;
        player.AddCustomAttribute("no_attack", 1, 25);
        player.RemoveCond(TF_COND_CRITBOOSTED);
        foreach (ent in player.GetAttachments())
            if (startswith(ent.GetClassname(), "tf_weapon"))
                ent.Kill();
        player.Weapon_Switch(player.GetScriptScope().EquipWeapon(GetWeaponTypeByName("loser")));
        player.GetScriptScope().RefreshCharacter(true);
    }
});

::GetSortedScores <- function()
{
    local array = [];
    foreach(k, v in GetScores())
        array.push([k, v]);
    return array.sort(function(it, that) {
        return that[1] - it[1];
    });
}