self.SetHudHideFlags(/*HIDEHUD_PIPES_AND_CHARGE | HIDEHUD_METAL |*/ HIDEHUD_BUILDING_STATUS | HIDEHUD_CLOAK_AND_FEIGN);

if (redTeamOnly && self.GetTeam() != TF_TEAM_RED)
{
    self.SwitchTeam(TF_TEAM_RED);
    self.ForceRespawn();
}

local mercModel = null;
local playerInTaunt = false;

AddTimer(-1, -10, function()
{
    local inCond = self.InCond(TF_COND_TAUNTING);
    if (inCond && !playerInTaunt)
    {
        playerInTaunt = true;
        KillIfValid(mercModel);
    }
    else if (!inCond && playerInTaunt)
    {
        playerInTaunt = false;
    }
});

OnSelfEvent("init_custom_character", 0, function()
{
    CreateViewModel(characterSettings.viewmodel);

    SetPropInt(self, "m_Shared.m_bShieldEquipped", 0);
    AssembleArsenal(false);

    //Add Merc's attributes
    self.AddCustomAttribute("cancel falling damage", 1, -1);
    self.AddCustomAttribute("crit mod disabled hidden", 0, -1);
    self.AddCustomAttribute("voice pitch scale", 0, -1);
    self.AddCustomAttribute("no double jump", 1, -1);
    self.AddCustomAttribute("rocket jump damage reduction", 0.4, -1);
    self.AddCond(TF_COND_BURNING_PYRO);

    //On-spawn invul
    if (GetRoundState() == 3)
        self.AddCustomAttribute("no_attack", 1, 5.2);
    //self.AddCondEx(TF_COND_INVULNERABLE, GetRoundState() == 3 ? 5 : 2, null);

    //Spawn sound
    if (GetRoundState() >= 4)
        BuildSound("respawn_sfx").Play();
});

function RefreshCharacter(keepCurrentHP = true)
{
    local oldHP = self.GetHealth();
    local weaponTT = GetWeaponTypeFromEntity(self.GetActiveWeapon());
    local playerClass = safeget(weaponTT, "playerclass", null);

    if (playerClass)
        self.SetPlayerClass(playerClass);
    else
        playerClass = self.GetPlayerClass();
    self.AddCustomAttribute("move speed bonus",
        1.04 / MERC_MOVESPEED_MULTIPLIER[playerClass],
        -1);

    FixViewmodels();

    local model = safeget(weaponTT, "playermodel", null);
    if (model)
        self.SetCustomModelWithClassAnimations(model);

    self.SetHealth(keepCurrentHP ? oldHP : 150);
    self.SetMaxHealth(150);
    self.RemoveCustomAttribute("max health additive penalty");
    self.AddCustomAttribute("max health additive penalty", MERC_HP_OFFSETS[playerClass], -1);
}

OnSelfEvent("player_death", -100, function()
{
    self.SetScriptOverlayMaterial("");
    game_text_hop_bar.Display(" ", self);
    BuildSound("death").Voice().SoundLevel(90).Play();
});

OnSelfEvent("OnDealDamage", function(params)
{
    if ((params.damage_type & 128) && self.InCond(TF_COND_BLASTJUMPING))
        params.damage *= 2;
});

local moveKeys = IN_ATTACK | IN_ATTACK2 | IN_FORWARD | IN_BACK | IN_MOVELEFT | IN_MOVERIGHT;

AddTimer(-1, 0, function()
{
    if (GetPropInt(self, "m_nButtons") & moveKeys && GetRoundState() > 3)
    {
        self.RemoveCond(TF_COND_INVULNERABLE);
    }
})
