cosmetics <- {
    mesh = [
       ["models/dmgg/player/mercenary_mesh.mdl", true]
    ]
    /*hats = [
        ["models/player/items/soldier/armored_authority.mdl", false],
        ["models/player/items/soldier/asian_merc.mdl", false],
    ]*/
}

local wearableEnts = [];

function ApplyCosmetics()
{
    local seed = playerSeed[self.entindex()];

    foreach (cosmeticType in cosmetics)
    {
        local entry = cosmeticType[seed % cosmeticType.len()];
        local wearable = CreateWorldModel(entry[0]);
        SetEntityColor(wearable, CalcMercColor());
        wearableEnts.push(wearable);
    }
}

OnSelfEvent("init_custom_character", 5, ApplyCosmetics);

function CalcMercColor()
{
    local steamId = GetPropString(self, "m_szNetworkIDString");
    local indexStr = steamId.len() > 5 ? steamId.slice(5) : "4444444";
    local index = indexStr.tointeger();
    return [index % 256, (index >> 8) % 256, (index >> 16) % 256, 255];
}

local playerInTaunt = false;

AddTimer(-1, -10, function()
{
    local inCond = self.InCond(TF_COND_TAUNTING);
    if (inCond && !playerInTaunt)
    {
        playerInTaunt = true;
        foreach (ent in wearableEnts)
            KillIfValid(ent);
        wearableEnts = [];
        ApplyCosmetics();
    }
    else if (!inCond && playerInTaunt)
        playerInTaunt = false;
});