OnSelfEvent("player_death_next", 0, function()
{
    SetPropBool(GetPropEntity(self, "m_hRagdoll"), "m_bGib", false);
});

OnSelfEvent("player_death_post", 0, function()
{
    local ragdoll = GetPropEntity(self, "m_hRagdoll");
    SetPropBool(ragdoll, "m_bGib", false);
    EntFireByHandle(ragdoll, "Kill", "", 8, ragdoll, ragdoll);

    local seed = playerSeed[self.entindex()];
    local gibs = [];

    foreach (cosmeticType in cosmetics)
    {
        local entry = cosmeticType[seed % cosmeticType.len()];
        if (entry[1])
        {
            local wearable = CreateWearableProp(ragdoll, entry[0]);
            SetEntityColor(wearable, CalcMercColor());
            EntFireByHandle(wearable, "Kill", "", 8, ragdoll, ragdoll);
        }
        else
            gibs.push(entry[0]);
    }
    ShootGibs(gibs, self.EyePosition() + Vector(0, 0, 65), self.GetAbsAngles())
});

function CreateWearableProp(ragdoll, modelName)
{
    local propModel = SpawnEntityFromTable("prop_dynamic", {
        model = modelName
    });
    propModel.SetSolid(0);
    propModel.SetMoveType(0, 0);
    SetPropInt(propModel, "m_fEffects", 129);
    SetPropInt(propModel, "m_nNextThinkTick", 0x7FFFFFFF);
    EntFireByHandle(propModel, "SetParent", "!activator", -1, ragdoll, ragdoll);
	return propModel;
}

function ShootGibs(gibs, origin, angles)
{
    local gibSpawner = SpawnEntityFromTable("env_shooter",
    {
        spawnflags = 5,
        m_iGibs = 1,
        m_flVelocity = 440,
        scale = 1,
        m_flVariance = 0,
        m_flGibLife = 8,
        shootsounds = 3,
        simulation = 1,
        nogibshadows = true
        origin = origin
        angles = angles
    });
    for (local i = 0; i < gibs.len(); i++)
    {
        EntFireByHandle(gibSpawner, "AddOutput", "shootmodel " + gibs[i], i * 0.02, null, null);
        EntFireByHandle(gibSpawner, "Shoot", "", i * 0.02, null, null);
    }
    EntFireByHandle(gibSpawner, "Kill", "", 3, null, null);
}